package style_Net_01;

import java.util.ArrayList;

import repast.simphony.space.continuous.ContinuousSpace;
import repast.simphony.space.grid.Grid;
import repast.simphony.space.grid.GridPoint;

public class AggSite {
	
	private ContinuousSpace <Object > space;
	private static Grid <Object > aggGrid;
	
	// INSTANCE VARIABLES  
	public int 	   		aggId;			            // unique id number for each parcel
	public int           x;
	public int           y;
	public ArrayList<Person>      	populationList = new ArrayList <Person> ();     // list of people  
	public ArrayList<Group>	        aggGroupList = new ArrayList <Group> ();            // list of groups that report to this agg site
	
	// CONSTRUCTOR
	public AggSite (int id) {
		populationList.clear();
		aggId = id;
	}

	//AGGSITE METHOD 1: Add Person to Population List
	public void addPersonToPopulationList (Person addPerson) {
		populationList.add(addPerson);
	}
		
	//AGGSITE METHOD 2: Remove Person from Population List (check when this is called!!!)
	public void removePersonFromPopulationList (Person removePerson) {
		populationList.remove(removePerson);
	}
	
	// AGGSITE METHOD 3: Add Group to List
	public void addGroupToList (Group addGroup) {
		aggGroupList.add(addGroup);
	}
	
	// AGGSITE METHOD 4: Add People to Groups
	public void addPeopleToGroups(int groupSize) {
		int groupPopCount = 0;

		for (Group aggGroup : aggGroupList) {       ///for each group on list

			aggGroup.setX(x);         //set group's coordinates to match agg site
			aggGroup.setY(y);

			for (int i = 0; i < groupSize; ++i) {
				Person groupPerson = populationList.get(groupPopCount);      //get this person from list
				aggGroup.addPersonToGroup (groupPerson);                     //add the person to the group's list
				groupPerson.setGroup(aggGroup);
				++groupPopCount;                               //increment this number
			}
			
			//System.out.printf("Agg Site %d: %d people in group\n", id, aggGroup.getNumMembers());
		}
	}

	public int getPopulation() {
		//System.out.printf("AggSite %d population %d\n", id, populationList.size());
		return populationList.size();
		
	}

	////////////////////////////////////////////////////////////////////////////
	// SETTERS AND GETTERS
	public int getAggId() {  return aggId; }
	public void setAggId( int i) { aggId = i; }
	
	public int getAggX() {return x;}
	public void setAggX (int i) { x = i; }
	
	public int getAggY() {return y;}
	public void setAggY (int i) { y = i; }

}
