package style_Net_01;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;

import repast.simphony.engine.environment.RunEnvironment;
import repast.simphony.engine.schedule.ScheduledMethod;
import repast.simphony.essentials.RepastEssentials;
import repast.simphony.random.RandomHelper;
import repast.simphony.space.continuous.ContinuousSpace;
import repast.simphony.space.grid.Grid;

public class Model {

	public static void setSpaceAndGrid(ContinuousSpace<Object> space, Grid<Object> grid) {
	}

	// PARAMETERS AND VARIABLES
	public static int modelRunId;
	public static int sizeX = 800; //each cell = 10 km
	public static int sizeY = 800;
	
	public static int stepsPerYear; // number of steps that represent one year
	
	public static int numPersonsPerAggSite; // n persons per aggregation site
	public static int numAggSites;
	public static int numLithicSources;
	
	public static int groupSize; // n artifact makers i each foraging group
	public static int maxGroupSize; // maximum number in a group
	public static int minGroupSize; // minimum number in a group
	
	public static int season; // make 2 seasons
	public static int seasonTick; // track number of weeks to change seasons
	public static int season1Ticks; // number of ticks in Season 1
	public static int currentTick; // current tickCount

	public static int timePeriod;
	public static int t1Start;
	public static int t1Stop;
	public static int t2Start;
	public static int t2Stop;
	
	public static int toolInventorySize;
	public static int toolUseLife;
	public static int toolUsesPerStep;
	public static double exhaustionIndex; 
	
	public static int productionFactor; //to control overproduction at lithic sources
	public static boolean replacement;  //switch to re-tool when near source area
	
	public static int targetSampleSize;          //number of points for individual point sample
	public static int minDistanceSample;

	// group movement
	public static int moveDistance; // distance (in cells) that group moves
	
	// personal movement
	public static double pGroupChange; // probability that a person will try to switch groups
	public static int personalMobilityRadius; // radius of personal movement
	public static double pInterAggMovement; // probability of inter-agg movement

	// summary and analysis variables (these are only recorded during T1 and T2)
	public static int numInterAggMoves; // number of moves between agg sites
	public static int numInterGroupMoves; // number of moves between groups
	public static double meanTransportDistance = 0; //mean distance (in km) that tools from known sources traveled
	public static double maxTransportDistance = 0; //maximum distance (in km) that tools from known sources traveled
	public static double maxRangeKm;          //actual maximum distance that groups traveled from agg site

	//lists for the system
	public static ArrayList<AggSite> aggSiteList = new ArrayList<AggSite>(); 
	public static ArrayList<LithicSource> lithicSourceList = new ArrayList<LithicSource>();
	public static ArrayList<Person> personList = new ArrayList<Person>(); // people
	public static ArrayList<Group> groupList = new ArrayList<Group>(); // groups
	public static ArrayList<Artifact> discardList = new ArrayList<Artifact>(); 
	
	//lists for analysis at the end of a data collection period	
	public static ArrayList<Artifact> list_0_20 = new ArrayList<Artifact>();
	public static ArrayList<Artifact> list_20_40 = new ArrayList<Artifact>();
	public static ArrayList<Artifact> list_40_60 = new ArrayList<Artifact>();
	public static ArrayList<Artifact> list_60_80 = new ArrayList<Artifact>();
	public static ArrayList<Artifact> list_80_100 = new ArrayList<Artifact>();
	public static ArrayList<Artifact> list_100_120 = new ArrayList<Artifact>();
	public static ArrayList<Artifact> list_120_140 = new ArrayList<Artifact>();
	public static ArrayList<Artifact> list_140_160 = new ArrayList<Artifact>();
	public static ArrayList<Artifact> list_160_180 = new ArrayList<Artifact>();
	public static ArrayList<Artifact> list_180_200 = new ArrayList<Artifact>();
	public static ArrayList<Artifact> list_200_220 = new ArrayList<Artifact>();
	public static ArrayList<Artifact> list_220_240 = new ArrayList<Artifact>();
	public static ArrayList<Artifact> list_240_260 = new ArrayList<Artifact>();
	public static ArrayList<Artifact> list_260_280 = new ArrayList<Artifact>();
	public static ArrayList<Artifact> list_280_300 = new ArrayList<Artifact>();
	public static ArrayList<Artifact> list_300_320 = new ArrayList<Artifact>();
	public static ArrayList<Artifact> list_320_340 = new ArrayList<Artifact>();
	public static ArrayList<Artifact> list_340_360 = new ArrayList<Artifact>();
	public static ArrayList<Artifact> list_360_380 = new ArrayList<Artifact>();
	public static ArrayList<Artifact> list_380_400 = new ArrayList<Artifact>();
	public static ArrayList<Artifact> list_400_420 = new ArrayList<Artifact>();
	public static ArrayList<Artifact> list_420_440 = new ArrayList<Artifact>();
	public static ArrayList<Artifact> list_440_460 = new ArrayList<Artifact>();
	public static ArrayList<Artifact> list_460_480 = new ArrayList<Artifact>();
	public static ArrayList<Artifact> list_480_500 = new ArrayList<Artifact>();
	public static ArrayList<Artifact> list_500_520 = new ArrayList<Artifact>();
	public static ArrayList<Artifact> list_520_540 = new ArrayList<Artifact>();
	public static ArrayList<Artifact> list_540_560 = new ArrayList<Artifact>();
	public static ArrayList<Artifact> list_560_580 = new ArrayList<Artifact>();
	public static ArrayList<Artifact> list_580_600 = new ArrayList<Artifact>();
	public static ArrayList<Artifact> list_600_620 = new ArrayList<Artifact>();
	public static ArrayList<Artifact> list_620_640 = new ArrayList<Artifact>();
	public static ArrayList<Artifact> list_640_660 = new ArrayList<Artifact>();
	public static ArrayList<Artifact> list_660_680 = new ArrayList<Artifact>();
	public static ArrayList<Artifact> list_680_700 = new ArrayList<Artifact>();
	public static ArrayList<Artifact> list_700_720 = new ArrayList<Artifact>();
	public static ArrayList<Artifact> list_720_740 = new ArrayList<Artifact>();
	public static ArrayList<Artifact> list_740_760 = new ArrayList<Artifact>();
	public static ArrayList<Artifact> list_760_780 = new ArrayList<Artifact>();
	public static ArrayList<Artifact> list_780_800 = new ArrayList<Artifact>();
	public static ArrayList<Artifact> list_800_820 = new ArrayList<Artifact>();
	public static ArrayList<Artifact> list_820_840 = new ArrayList<Artifact>();
	public static ArrayList<Artifact> list_840_860 = new ArrayList<Artifact>();
	public static ArrayList<Artifact> list_860_880 = new ArrayList<Artifact>();
	public static ArrayList<Artifact> list_880_900 = new ArrayList<Artifact>();
	public static ArrayList<Artifact> list_900_920 = new ArrayList<Artifact>();
	public static ArrayList<Artifact> list_920_940 = new ArrayList<Artifact>();
	public static ArrayList<Artifact> list_940_960 = new ArrayList<Artifact>();
	public static ArrayList<Artifact> list_960_980 = new ArrayList<Artifact>();
	public static ArrayList<Artifact> list_980_1000 = new ArrayList<Artifact>();
	
	public static double percentSourced_0_20;
	public static double percentSourced_20_40;
	public static double percentSourced_40_60;
	public static double percentSourced_60_80;
	public static double percentSourced_80_100;
	public static double percentSourced_100_120;
	public static double percentSourced_120_140;
	public static double percentSourced_140_160;
	public static double percentSourced_160_180;
	public static double percentSourced_180_200;
	public static double percentSourced_200_220;
	public static double percentSourced_220_240;
	public static double percentSourced_240_260;
	public static double percentSourced_260_280;
	public static double percentSourced_280_300;
	public static double percentSourced_300_320;
	public static double percentSourced_320_340;
	public static double percentSourced_340_360;
	public static double percentSourced_360_380;
	public static double percentSourced_380_400;
	public static double percentSourced_400_420;
	public static double percentSourced_420_440;
	public static double percentSourced_440_460;
	public static double percentSourced_460_480;
	public static double percentSourced_480_500;
	public static double percentSourced_500_520;
	public static double percentSourced_520_540;
	public static double percentSourced_540_560;
	public static double percentSourced_560_580;
	public static double percentSourced_580_600;
	public static double percentSourced_600_620;
	public static double percentSourced_620_640;
	public static double percentSourced_640_660;
	public static double percentSourced_660_680;
	public static double percentSourced_680_700;
	public static double percentSourced_700_720;
	public static double percentSourced_720_740;
	public static double percentSourced_740_760;
	public static double percentSourced_760_780;
	public static double percentSourced_780_800;
	public static double percentSourced_800_820;
	public static double percentSourced_820_840;
	public static double percentSourced_840_860;
	public static double percentSourced_860_880;
	public static double percentSourced_880_900;
	public static double percentSourced_900_920;
	public static double percentSourced_920_940;
	public static double percentSourced_940_960;
	public static double percentSourced_960_980;
	public static double percentSourced_980_1000;
	
	// SETUP PARAMETERS
	public static void setupParams() {
		
		modelRunId = RandomHelper.nextIntFromTo(1,  1000000000);

		numPersonsPerAggSite = 60;
		groupSize = 6;
		maxGroupSize = 7;
		minGroupSize = 2;
		
		numAggSites = 1;
		numLithicSources = 1;
		
		season = 1;
		seasonTick = 0; // start clock at 0 -- it gets incremented to "1" before first move
		season1Ticks = 25; //groups will move away from aggsite on ticks 1-24
		stepsPerYear = 52; // each step represents a week
		currentTick = 0;

		t1Start = 20800; // T1 starts at this tick (20800 ticks = 400 years)
		t1Stop = 26000; // T1 stops at this tick (26000 ticks = 500 years)
		
		t2Start = 46800; //T2 starts at this tick
		t2Stop = 52000;
		
		timePeriod = 0;
		
		moveDistance = 2;
		//moveDistance = RandomHelper.nextIntFromTo(1, 5);
		
		toolInventorySize = 27;         //number of tools in standard inventory
		//toolInventorySize = RandomHelper.nextIntFromTo(1, 50);
		toolUseLife = 9;
		//toolUseLife = RandomHelper.nextIntFromTo (1, 10);
		toolUsesPerStep =3;
		//toolUsesPerStep = RandomHelper.nextIntFromTo (1, 10);
		productionFactor = 2;
		//productionFactor = RandomHelper.nextIntFromTo(1, 2);
		//replacement = false;
		replacement = true;
		
		minDistanceSample = 100;       //this many artifacts required to calculate percentage
		
		targetSampleSize = 10000;   //total we'd like to have in all the bins combined
		
		pGroupChange = 0;
		//pGroupChange = RandomHelper.nextDoubleFromTo (0, 1);
		personalMobilityRadius = 1;
		pInterAggMovement = 0;
		//pInterAggMovement = RandomHelper.nextDoubleFromTo(-0.05, 1);
		numInterAggMoves = 0;
		numInterGroupMoves = 0;
		maxRangeKm = 0;
		
		//clear classes at the start of a run
		if (aggSiteList.size() != 0) { // if there are agg sites
			for (AggSite deleteAgg : aggSiteList) { // go through aggList
				deleteAgg = null; // null out the agg sites
			}
		}

		if (personList.size() != 0) { // if there are people
			for (Person deletePerson : personList) { // go through personList
				deletePerson = null; // null out the people
			}
		}

		if (groupList.size() != 0) { // if there are groups
			for (Group deleteGroup : groupList) { // go through groupList
				deleteGroup = null; // null out the people
			}
		}
		
		if (discardList.size() != 0) {
			for (Artifact deleteArtifact : discardList) {
				deleteArtifact = null;
			}
		}

		//clear lists at the start of a run	
		aggSiteList.clear();
		lithicSourceList.clear();
		personList.clear();
		groupList.clear();
		discardList.clear();
		
		clearDistanceLists();
		
		percentSourced_0_20 = 0;
		percentSourced_20_40 = 0;
		percentSourced_40_60 = 0;
		percentSourced_60_80 = 0;
		percentSourced_80_100 = 0;
		percentSourced_100_120 = 0;
		percentSourced_120_140 = 0;
		percentSourced_140_160 = 0;
		percentSourced_160_180 = 0;
		percentSourced_180_200 = 0;
		percentSourced_200_220 = 0;
		percentSourced_220_240 = 0;
		percentSourced_240_260 = 0;
		percentSourced_260_280 = 0;
		percentSourced_280_300 = 0;
		percentSourced_300_320 = 0;
		percentSourced_320_340 = 0;
		percentSourced_340_360 = 0;
		percentSourced_360_380 = 0;
		percentSourced_380_400 = 0;
		percentSourced_400_420 = 0;
		percentSourced_420_440 = 0;
		percentSourced_440_460 = 0;
		percentSourced_460_480 = 0;
		percentSourced_480_500 = 0;
		percentSourced_500_520 = 0;
		percentSourced_520_540 = 0;
		percentSourced_540_560 = 0;
		percentSourced_560_580 = 0;
		percentSourced_580_600 = 0;
		percentSourced_600_620 = 0;
		percentSourced_620_640 = 0;
		percentSourced_640_660 = 0;
		percentSourced_660_680 = 0;
		percentSourced_680_700 = 0;
		percentSourced_700_720 = 0;
		percentSourced_720_740 = 0;
		percentSourced_740_760 = 0;
		percentSourced_760_780 = 0;
		percentSourced_780_800 = 0;
		percentSourced_800_820 = 0;
		percentSourced_820_840 = 0;
		percentSourced_840_860 = 0;
		percentSourced_860_880 = 0;
		percentSourced_880_900 = 0;
		percentSourced_900_920 = 0;
		percentSourced_920_940 = 0;
		percentSourced_940_960 = 0;
		percentSourced_960_980 = 0;
		percentSourced_980_1000 = 0;
	}

	//MODEL METHOD 1: Create Aggregation Site(S)
	public static void createAggSites() {
	
		AggSite agg1 = new AggSite(1);
		aggSiteList.add(agg1);
		agg1.setAggX(400);
		agg1.setAggY(400);
	}
	
	//MODEL METHOD 2: Create Lithic Source(s)
	public static void createLithicSources() {
				
		LithicSource ls1 = new LithicSource(1);
		lithicSourceList.add(ls1);
		ls1.setLithicSourceX (400);
		ls1.setLithicSourceY (400);
		}
			
	//MODEL METHOD 3: Create People
	public static void createPeople() {

		int numPeople = numPersonsPerAggSite * aggSiteList.size();

		for (int personCount = 0; personCount < numPeople; ++personCount) {
			Person person = new Person(); // create a new person
			personList.add(person); // add to personList
		}
	}

	//MODEL METHOD 4: Assign People to Aggregation Sites
	public static void assignPeopleToAggSites() {

		int populationCount = 0;

		for (AggSite popAgg : aggSiteList) { // go through each aggSite on list

			for (int i = 0; i < numPersonsPerAggSite; ++i) {
				Person addPerson = personList.get(populationCount); 
				popAgg.addPersonToPopulationList(addPerson); 
				addPerson.setAggSite(popAgg); // set the person's aggSite
				++populationCount; // increment this number
			}
		}
	}

	//MODEL METHOD 5: Assign People to Groups
	public static void assignPeopleToGroups() {

		int groupCount = 0;

		for (AggSite popAgg : aggSiteList) { // go through each aggSite on list
			
			int numGroups = popAgg.getPopulation() / groupSize;

			for (int i = 0; i < numGroups; ++i) { 
				Group newGroup = new Group(groupCount, popAgg);

				popAgg.addGroupToList(newGroup);
				groupList.add(newGroup);
				++groupCount;
			}
			popAgg.addPeopleToGroups(groupSize);
		}
	}
	
	//MODEL METHOD 6: Step Method
	@ScheduledMethod(start = 1, interval = 1)
	public void step() {
		checkSeason(); 			 //Method 7
		moveGroups();   		 //Method 8
		artifactMethods();		 //Method 9
		movePersons();			 //Method 10
		checkTickCount();        //Method 11
	}

	//MODEL METHOD 7: Check Season
	public void checkSeason() {
		if (seasonTick == season1Ticks) // if we're ready to switch seasons
			season = 2; // change the season from 1 to 2

		if (seasonTick == stepsPerYear + 1) { // if the year is over
			season = 1; // change season back to 1
			seasonTick = 0; // reset the seasonTicks clock
		}
		++seasonTick; //increment this every step
	}

	//MODEL METHOD 8: Move Groups
	public void moveGroups() {
		for (Group group : groupList) // go through group list
			if (season == 1) { // if we're in dispersal season
				group.moveAwayFromAggSite(moveDistance); // move away from agg site
			} 
			else // if we're in aggregation season
				group.moveTowardAggSite(moveDistance); // move toward agg site
	}
	
	//MODEL METHOD 9: Artifact Methods
	public void artifactMethods() {
		for (Person person : personList) { // for each person on list
			person.checkLithicSourceProximity();
			
			if (replacement == true) {      //if replacement is on
				if (person.getProximateLithicSource() != null) {   //and if person is near a lithic source
					person.discardUsedTools(); } //discard used tools if near a lithic source
			}
			person.createTools();
			person.useTools(); 
		}
	}

	//MODEL METHOD 10: Move Persons
	public void movePersons() {
		for (Person person : personList) { // go through personList
			double roll = RandomHelper.nextDoubleFromTo(0, 1); // roll dice

			if (roll <= pGroupChange) { // if roll is low enough
				Group personGroup = person.getGroup(); // get group
				int groupSize = personGroup.getSize(); // get size of group
				if (groupSize >= minGroupSize + 1) { 
					person.changeGroups(personalMobilityRadius); 
				}
			}
		}
	}
	
	//MODEL METHOD 11: Check Tick Count
	public void checkTickCount() {
		currentTick = (int) RepastEssentials.GetTickCount(); // get current tick

		if (currentTick == t1Start) { // if reached start of T1
			timePeriod = 1;  //set this to 1
			System.out.printf("Starting T1\n");
		}

		if (currentTick == t1Stop - 1) {
			recordSummaryData();
			//recordPointSampleData();
			discardList.clear();                 //clear this list for time 2
			timePeriod = 0;  //set this to zero to stop collecting artifact data
			numInterAggMoves = 0; //set this to zero to re-start count
			endRun();  //put this in for simple runs not doing a T2
		}
		
		if (currentTick == t2Start) { //if at start of second period
			timePeriod = 2;
			System.out.printf("Starting T2\n");
		}
		
		if (currentTick == t2Stop - 1) {
			endRun();
		}
	}

	//MODEL METHOD 12: Record Summary Data
	public void recordSummaryData() {

	System.out.printf("MODEL: reporting summaryData\n");
		
		//settings and parameters
		String s = String.format("%d ", Style_Net_01Builder.getRunNumber());
		s += String.format(" %d ", modelRunId);
		s += String.format(" %d ", toolInventorySize);
		s += String.format(" %d ", toolUseLife);
		s += String.format(" %d ", toolUsesPerStep);
		s += String.format(" %d ", productionFactor);
		
		if (replacement == true) {
			s += String.format(" On ");
		}
		
		else {
			s += String.format(" Off ");
		}
		
		exhaustionIndex = (double)toolInventorySize * (double)toolUseLife / (double)toolUsesPerStep;
		
		s += String.format(" %5.2f ", exhaustionIndex);
		//s += String.format(" %d ", numPersonsPerAggSite);
		//s += String.format(" %5.5f ", pInterAggMovement);
		//s += String.format(" %5.3f ", pGroupChange);
		//s += String.format(" %d ", numInterGroupMoves);
		//s += String.format(" %d ", numInterAggMoves);
		s += String.format(" %d ", moveDistance);      
		s += String.format(" %d ", personalMobilityRadius);
		s += String.format(" %5.1f ", maxRangeKm);  //max range in km
		s += String.format(" %d ", timePeriod);
		s += String.format(" %d ", discardList.size());

		calculateMeanTransportDistance();
		s += String.format(" %5.1f ", meanTransportDistance);
		
		calculateMaxTransportDistance();
		s += String.format(" %5.1f ", maxTransportDistance);
				
		//sort discard list into bins by distance
		sortDiscardedArtifacts();
		calculatePercentages();
		
		//report percentages
		s += String.format(" %5.2f ", percentSourced_0_20);
		s += String.format(" %5.2f ", percentSourced_20_40);
		s += String.format(" %5.2f ", percentSourced_40_60);
		s += String.format(" %5.2f ", percentSourced_60_80);
		s += String.format(" %5.2f ", percentSourced_80_100);
		s += String.format(" %5.2f ", percentSourced_100_120);
		s += String.format(" %5.2f ", percentSourced_120_140);
		s += String.format(" %5.2f ", percentSourced_140_160);
		s += String.format(" %5.2f ", percentSourced_160_180);
		s += String.format(" %5.2f ", percentSourced_180_200);
		s += String.format(" %5.2f ", percentSourced_200_220);
		s += String.format(" %5.2f ", percentSourced_220_240);
		s += String.format(" %5.2f ", percentSourced_240_260);
		s += String.format(" %5.2f ", percentSourced_260_280);
		s += String.format(" %5.2f ", percentSourced_280_300);
		s += String.format(" %5.2f ", percentSourced_300_320);
		s += String.format(" %5.2f ", percentSourced_320_340);
		s += String.format(" %5.2f ", percentSourced_340_360);
		s += String.format(" %5.2f ", percentSourced_360_380);
		s += String.format(" %5.2f ", percentSourced_380_400);
		s += String.format(" %5.2f ", percentSourced_400_420);
		s += String.format(" %5.2f ", percentSourced_420_440);
		s += String.format(" %5.2f ", percentSourced_440_460);
		s += String.format(" %5.2f ", percentSourced_460_480);
		s += String.format(" %5.2f ", percentSourced_480_500);
		s += String.format(" %5.2f ", percentSourced_500_520);
		s += String.format(" %5.2f ", percentSourced_520_540);
		s += String.format(" %5.2f ", percentSourced_540_560);
		s += String.format(" %5.2f ", percentSourced_560_580);
		s += String.format(" %5.2f ", percentSourced_580_600);
		s += String.format(" %5.2f ", percentSourced_600_620);
		s += String.format(" %5.2f ", percentSourced_620_640);
		s += String.format(" %5.2f ", percentSourced_640_660);
		s += String.format(" %5.2f ", percentSourced_660_680);
		s += String.format(" %5.2f ", percentSourced_680_700);
		s += String.format(" %5.2f ", percentSourced_700_720);
		s += String.format(" %5.2f ", percentSourced_720_740);
		s += String.format(" %5.2f ", percentSourced_740_760);
		s += String.format(" %5.2f ", percentSourced_760_780);
		s += String.format(" %5.2f ", percentSourced_780_800);
		s += String.format(" %5.2f ", percentSourced_800_820);
		s += String.format(" %5.2f ", percentSourced_820_840);
		s += String.format(" %5.2f ", percentSourced_840_860);
		s += String.format(" %5.2f ", percentSourced_860_880);
		s += String.format(" %5.2f ", percentSourced_880_900);
		s += String.format(" %5.2f ", percentSourced_900_920);
		s += String.format(" %5.2f ", percentSourced_920_940);
		s += String.format(" %5.2f ", percentSourced_940_960);
		s += String.format(" %5.2f ", percentSourced_960_980);
		s += String.format(" %5.2f ", percentSourced_980_1000);
		
		nullDiscardedArtifacts();   //make sure to get rid of all the artifacts before the next run
		
		doSummaryAppend(s); // send data to be appended to a file
	}

	//MODEL METHOD 13: Append Summary Data
	public void doSummaryAppend(String s) {

		try {
			String fileName = "SummaryLithicTransport.txt";
			BufferedWriter out = new BufferedWriter(new FileWriter(fileName, true));
			out.write(s);
			out.write("\n");
			System.out.printf("MODEL: summaryData written\n");
			out.close();
		}

		catch (IOException e) {
			System.out.println("IOException:");
			e.printStackTrace();
		}
	}
	
	//MODEL METHOD 14: Calculate Mean Transport Distance
	public void calculateMeanTransportDistance() {
		
		double transportDistance = 0;
		int numSourcedArtifacts = 0;
		
		for (Artifact sourcedArtifact : discardList) {   //go through discard list
			if (sourcedArtifact.getLithicRawMaterial() != null) {  //if the artifact is from a recognized source
				++numSourcedArtifacts;
				transportDistance = transportDistance + sourcedArtifact.getSourceDiscardDistance();
			}
		}
		meanTransportDistance = transportDistance / (double) numSourcedArtifacts;
	}
	
	//MODEL METHOD 15: Calculate Max Transport Distance
	public void calculateMaxTransportDistance() {
		
		double maxDistance = 0;
				
		for (Artifact sourcedArtifact : discardList) {   //go through discard list
			if (sourcedArtifact.getLithicRawMaterial() != null) {  //if the artifact is from a recognized source
				double transportDistance = sourcedArtifact.getSourceDiscardDistance();
				if (transportDistance > maxDistance) {       //if greatest distance yet
					maxDistance = transportDistance;          //record it
				}
			}
		}
		maxTransportDistance = maxDistance;
	}

	//MODEL METHOD 16: Sort Discarded Artifacts into Distance Bins
	public void sortDiscardedArtifacts() {
		
		//check sample size
		if (discardList.size() < targetSampleSize) { //if not enough artifacts
			System.out.printf("ERROR: not enough artifacts!\n");
			endRun();
		}
		
		for (Artifact sampleTool : discardList) {
			double distance = sampleTool.getSourceDiscardDistance(); //get distance
			
			if (distance <= 20) { list_0_20.add(sampleTool); }
			if (distance <= 40) { 
					if (distance > 20) {list_20_40.add(sampleTool); }}
			if (distance <= 60) { 
					if (distance > 40) {list_40_60.add(sampleTool); }}
			if (distance <= 80) { 
					if (distance > 60) {list_60_80.add(sampleTool); }}
			if (distance <= 100) { 
				if (distance > 80) {list_80_100.add(sampleTool); }}		
			if (distance <= 120) { 
				if (distance > 100) {list_100_120.add(sampleTool); }}				
			if (distance <= 140) { 
				if (distance > 120) {list_120_140.add(sampleTool); }}		
			if (distance <= 160) { 
				if (distance > 140) {list_140_160.add(sampleTool); }}	
			if (distance <= 180) { 
				if (distance > 160) {list_160_180.add(sampleTool); }}	
			if (distance <= 200) { 
				if (distance > 180) {list_180_200.add(sampleTool); }}	
			if (distance <= 220) { 
				if (distance > 200) {list_200_220.add(sampleTool); }}	
			if (distance <= 240) { 
				if (distance > 220) {list_220_240.add(sampleTool); }}
			if (distance <= 260) { 
				if (distance > 240) {list_240_260.add(sampleTool); }}
			if (distance <= 280) { 
				if (distance > 260) {list_260_280.add(sampleTool); }}
			if (distance <= 300) { 
				if (distance > 280) {list_280_300.add(sampleTool); }}
			if (distance <= 320) { 
				if (distance > 300) {list_300_320.add(sampleTool); }}
			if (distance <= 340) { 
				if (distance > 320) {list_320_340.add(sampleTool); }}
			if (distance <= 360) { 
				if (distance > 340) {list_340_360.add(sampleTool); }}
			if (distance <= 380) { 
				if (distance > 360) {list_360_380.add(sampleTool); }}
			if (distance <= 400) { 
				if (distance > 380) {list_380_400.add(sampleTool); }}
			if (distance <= 420) { 
				if (distance > 400) {list_400_420.add(sampleTool); }}	
			if (distance <= 440) { 
				if (distance > 420) {list_420_440.add(sampleTool); }}
			if (distance <= 460) { 
				if (distance > 440) {list_440_460.add(sampleTool); }}
			if (distance <= 480) { 
				if (distance > 460) {list_460_480.add(sampleTool); }}
			if (distance <= 500) { 
				if (distance > 480) {list_480_500.add(sampleTool); }}
			if (distance <= 520) { 
				if (distance > 500) {list_500_520.add(sampleTool); }}
			if (distance <= 540) { 
				if (distance > 520) {list_520_540.add(sampleTool); }}
			if (distance <= 560) { 
				if (distance > 540) {list_540_560.add(sampleTool); }}
			if (distance <= 580) { 
				if (distance > 560) {list_560_580.add(sampleTool); }}
			if (distance <= 600) { 
				if (distance > 580) {list_580_600.add(sampleTool); }}
			if (distance <= 620) { 
				if (distance > 600) {list_600_620.add(sampleTool); }}	
			if (distance <= 640) { 
				if (distance > 620) {list_620_640.add(sampleTool); }}
			if (distance <= 660) { 
				if (distance > 640) {list_640_660.add(sampleTool); }}
			if (distance <= 680) { 
				if (distance > 660) {list_660_680.add(sampleTool); }}
			if (distance <= 700) { 
				if (distance > 680) {list_680_700.add(sampleTool); }}
			if (distance <= 720) { 
				if (distance > 700) {list_700_720.add(sampleTool); }}
			if (distance <= 740) { 
				if (distance > 720) {list_720_740.add(sampleTool); }}
			if (distance <= 760) { 
				if (distance > 740) {list_740_760.add(sampleTool); }}
			if (distance <= 780) { 
				if (distance > 760) {list_760_780.add(sampleTool); }}
			if (distance <= 800) { 
				if (distance > 780) {list_780_800.add(sampleTool); }}
			if (distance <= 820) { 
				if (distance > 800) {list_800_820.add(sampleTool); }}	
			if (distance <= 840) { 
				if (distance > 820) {list_820_840.add(sampleTool); }}
			if (distance <= 860) { 
				if (distance > 840) {list_840_860.add(sampleTool); }}
			if (distance <= 880) { 
				if (distance > 860) {list_860_880.add(sampleTool); }}
			if (distance <= 900) { 
				if (distance > 880) {list_880_900.add(sampleTool); }}
			if (distance <= 920) { 
				if (distance > 900) {list_900_920.add(sampleTool); }}
			if (distance <= 940) { 
				if (distance > 920) {list_920_940.add(sampleTool); }}
			if (distance <= 960) { 
				if (distance > 940) {list_940_960.add(sampleTool); }}
			if (distance <= 980) { 
				if (distance > 960) {list_960_980.add(sampleTool); }}
			if (distance <= 1000) { 
				if (distance > 980) {list_980_1000.add(sampleTool); }}
		}	
	}
	
	//MODEL METHOD 17: Calculate Percentages of Sourced Artifacts
	public void calculatePercentages() {
		
		if (percentSourced_0_20 != 0) {System.out.printf("Error - percentSourced is not 0 before calculation");}
		
		int numSourced = 0;              //number of sourced artifacts on a list
	
		if (list_0_20.size() != 0){         //if there are artifacts on list
			
			
			
			for (Artifact tool : list_0_20) {    //go through list
				if (tool.getLithicRawMaterial() != null)  //if it has a raw material
					++numSourced;                        //increment this
			}
			
			if (list_0_20.size() > minDistanceSample) {      //only calculate with sufficient sample
				percentSourced_0_20 = (double) numSourced / (double) list_0_20.size() * 100; //calculate percentage
			}
			
			numSourced = 0; //return this to 0 for next calculation
		}
		
		if (list_20_40.size() != 0){         //if there are artifacts on list
			
			for (Artifact tool : list_20_40) {    //go through list
				if (tool.getLithicRawMaterial() != null)  //if it has a raw material
					++numSourced;                        //increment this
			}
			
			if (list_20_40.size() > minDistanceSample) {      //only calculate with sufficient sample
				percentSourced_20_40 = (double) numSourced/ (double) list_20_40.size() * 100; //calculate percentage
			}
		
			numSourced = 0; //return this to 0 for next calculation
		}
	
		if (list_40_60.size() != 0){         //if there are artifacts on list
			
			for (Artifact tool : list_40_60) {    //go through list
				if (tool.getLithicRawMaterial() != null)  //if it has a raw material
					++numSourced;                        //increment this
			}
			
			if (list_40_60.size() > minDistanceSample) {      //only calculate with sufficient sample
				percentSourced_40_60 = (double) numSourced/ (double) list_40_60.size() * 100; //calculate percentage
			}
					
			numSourced = 0; //return this to 0 for next calculation
		}
		
		if (list_60_80.size() != 0){         //if there are artifacts on list
			
			for (Artifact tool : list_60_80) {    //go through list
				if (tool.getLithicRawMaterial() != null)  //if it has a raw material
					++numSourced;                        //increment this
			}
			
			if (list_60_80.size() > minDistanceSample) {      //only calculate with sufficient sample
				percentSourced_60_80 = (double) numSourced/ (double) list_60_80.size() * 100; //calculate percentage
			}
			numSourced = 0; //return this to 0 for next calculation
		}
		
		if (list_80_100.size() != 0){         //if there are artifacts on list
			
			for (Artifact tool : list_80_100) {    //go through list
				if (tool.getLithicRawMaterial() != null)  //if it has a raw material
					++numSourced;                        //increment this
			}
			
			if (list_80_100.size() > minDistanceSample) {      //only calculate with sufficient sample
				percentSourced_80_100 = (double) numSourced/ (double) list_80_100.size() * 100; //calculate percentage
			}
			numSourced = 0; //return this to 0 for next calculation
		}
		
		if (list_100_120.size() != 0){         //if there are artifacts on list
			
			for (Artifact tool : list_100_120) {    //go through list
				if (tool.getLithicRawMaterial() != null)  //if it has a raw material
					++numSourced;                        //increment this
			}
			if (list_100_120.size() > minDistanceSample) {      //only calculate with sufficient sample
				percentSourced_100_120 = (double) numSourced / (double) list_100_120.size() * 100; //calculate percentage
			}
			numSourced = 0; //return this to 0 for next calculation
		}
		
		if (list_120_140.size() != 0){         //if there are artifacts on list
			
			for (Artifact tool : list_120_140) {    //go through list
				if (tool.getLithicRawMaterial() != null)  //if it has a raw material
					++numSourced;                        //increment this
			}
			if (list_120_140.size() > minDistanceSample) {      //only calculate with sufficient sample
				percentSourced_120_140 = (double) numSourced/ (double) list_120_140.size() * 100; //calculate percentage
			}
			numSourced = 0; //return this to 0 for next calculation
		}
	
		if (list_140_160.size() != 0){         //if there are artifacts on list
			for (Artifact tool : list_140_160) {    //go through list
				if (tool.getLithicRawMaterial() != null)  //if it has a raw material
					++numSourced;                        //increment this
			}
			if (list_140_160.size() > minDistanceSample) {      //only calculate with sufficient sample
				percentSourced_140_160 = (double) numSourced/ (double) list_140_160.size() * 100; //calculate percentage
			}
			numSourced = 0; //return this to 0 for next calculation
		}
		
		if (list_160_180.size() != 0){         //if there are artifacts on list
			
			for (Artifact tool : list_160_180) {    //go through list
				if (tool.getLithicRawMaterial() != null)  //if it has a raw material
					++numSourced;                        //increment this
			}
			if (list_160_180.size() > minDistanceSample) {      //only calculate with sufficient sample
				percentSourced_160_180 = (double) numSourced/ (double) list_160_180.size() * 100; //calculate percentage
			}
			numSourced = 0; //return this to 0 for next calculation
		}
		
		if (list_180_200.size() != 0){         //if there are artifacts on list
			
			for (Artifact tool : list_180_200) {    //go through list
				if (tool.getLithicRawMaterial() != null)  //if it has a raw material
					++numSourced;                        //increment this
			}
			if (list_180_200.size() > minDistanceSample) {      //only calculate with sufficient sample
				percentSourced_180_200 = (double) numSourced/ (double) list_180_200.size() * 100; //calculate percentage
			}
			numSourced = 0; //return this to 0 for next calculation
		}
		
		if (list_200_220.size() != 0){         //if there are artifacts on list
			
			for (Artifact tool : list_200_220) {    //go through list
				if (tool.getLithicRawMaterial() != null)  //if it has a raw material
					++numSourced;                        //increment this
			}
			if (list_200_220.size() > minDistanceSample) {      //only calculate with sufficient sample
				percentSourced_200_220 = (double) numSourced / (double) list_200_220.size() * 100; //calculate percentage
			}
			numSourced = 0; //return this to 0 for next calculation
		}
		
		if (list_220_240.size() != 0){         //if there are artifacts on list
			
			for (Artifact tool : list_220_240) {    //go through list
				if (tool.getLithicRawMaterial() != null)  //if it has a raw material
					++numSourced;                        //increment this
			}
			if (list_220_240.size() > minDistanceSample) {      //only calculate with sufficient sample
				percentSourced_220_240 = (double) numSourced/ (double) list_220_240.size() * 100; //calculate percentage
			}
			numSourced = 0; //return this to 0 for next calculation
		}
	
		if (list_240_260.size() != 0){         //if there are artifacts on list
			for (Artifact tool : list_240_260) {    //go through list
				if (tool.getLithicRawMaterial() != null)  //if it has a raw material
					++numSourced;                        //increment this
			}
			if (list_240_260.size() > minDistanceSample) {      //only calculate with sufficient sample
				percentSourced_240_260 = (double) numSourced/ (double) list_240_260.size() * 100; //calculate percentage
			}
			numSourced = 0; //return this to 0 for next calculation
		}
		
		if (list_260_280.size() != 0){         //if there are artifacts on list
			
			for (Artifact tool : list_260_280) {    //go through list
				if (tool.getLithicRawMaterial() != null)  //if it has a raw material
					++numSourced;                        //increment this
			}
			if (list_260_280.size() > minDistanceSample) {      //only calculate with sufficient sample
				percentSourced_260_280 = (double) numSourced/ (double) list_260_280.size() * 100; //calculate percentage
			}
			numSourced = 0; //return this to 0 for next calculation
		}
		
		if (list_280_300.size() != 0){         //if there are artifacts on list
			
			for (Artifact tool : list_280_300) {    //go through list
				if (tool.getLithicRawMaterial() != null)  //if it has a raw material
					++numSourced;                        //increment this
			}
			if (list_280_300.size() > minDistanceSample) {      //only calculate with sufficient sample
				percentSourced_280_300 = (double) numSourced/ (double) list_280_300.size() * 100; //calculate percentage
			}
			numSourced = 0; //return this to 0 for next calculation
		}
		
		if (list_300_320.size() != 0){         //if there are artifacts on list
			
			for (Artifact tool : list_300_320) {    //go through list
				if (tool.getLithicRawMaterial() != null)  //if it has a raw material
					++numSourced;                        //increment this
			}
			if (list_300_320.size() > minDistanceSample) {      //only calculate with sufficient sample
				percentSourced_300_320 = (double) numSourced / (double) list_300_320.size() * 100; //calculate percentage
			}
			numSourced = 0; //return this to 0 for next calculation
		}
		
		if (list_320_340.size() != 0){         //if there are artifacts on list
			
			for (Artifact tool : list_320_340) {    //go through list
				if (tool.getLithicRawMaterial() != null)  //if it has a raw material
					++numSourced;                        //increment this
			}
			if (list_320_340.size() > minDistanceSample) {      //only calculate with sufficient sample
				percentSourced_320_340 = (double) numSourced/ (double) list_320_340.size() * 100; //calculate percentage
			}
			numSourced = 0; //return this to 0 for next calculation
		}
	
		if (list_340_360.size() != 0){         //if there are artifacts on list
			for (Artifact tool : list_340_360) {    //go through list
				if (tool.getLithicRawMaterial() != null)  //if it has a raw material
					++numSourced;                        //increment this
			}
			if (list_340_360.size() > minDistanceSample) {      //only calculate with sufficient sample
				percentSourced_340_360 = (double) numSourced/ (double) list_340_360.size() * 100; //calculate percentage
			}
			numSourced = 0; //return this to 0 for next calculation
		}
		
		if (list_360_380.size() != 0){         //if there are artifacts on list
			
			for (Artifact tool : list_360_380) {    //go through list
				if (tool.getLithicRawMaterial() != null)  //if it has a raw material
					++numSourced;                        //increment this
			}
			if (list_360_380.size() > minDistanceSample) {      //only calculate with sufficient sample
				percentSourced_360_380 = (double) numSourced/ (double) list_360_380.size() * 100; //calculate percentage
			}
			numSourced = 0; //return this to 0 for next calculation
		}
		
		if (list_380_400.size() != 0){         //if there are artifacts on list
			
			for (Artifact tool : list_380_400) {    //go through list
				if (tool.getLithicRawMaterial() != null)  //if it has a raw material
					++numSourced;                        //increment this
			}
			if (list_380_400.size() > minDistanceSample) {      //only calculate with sufficient sample
				percentSourced_380_400 = (double) numSourced/ (double) list_380_400.size() * 100; //calculate percentage
			}
			numSourced = 0; //return this to 0 for next calculation
		}
		
		if (list_400_420.size() != 0){         //if there are artifacts on list
			
			for (Artifact tool : list_400_420) {    //go through list
				if (tool.getLithicRawMaterial() != null)  //if it has a raw material
					++numSourced;                        //increment this
			}
			if (list_400_420.size() > minDistanceSample) {      //only calculate with sufficient sample
				percentSourced_400_420 = (double) numSourced / (double) list_400_420.size() * 100; //calculate percentage
			}
			numSourced = 0; //return this to 0 for next calculation
		}
		
		if (list_420_440.size() != 0){         //if there are artifacts on list
			
			for (Artifact tool : list_420_440) {    //go through list
				if (tool.getLithicRawMaterial() != null)  //if it has a raw material
					++numSourced;                        //increment this
			}
			if (list_420_440.size() > minDistanceSample) {      //only calculate with sufficient sample
				percentSourced_420_440 = (double) numSourced/ (double) list_420_440.size() * 100; //calculate percentage
			}
			numSourced = 0; //return this to 0 for next calculation
		}
	
		if (list_440_460.size() != 0){         //if there are artifacts on list
			for (Artifact tool : list_440_460) {    //go through list
				if (tool.getLithicRawMaterial() != null)  //if it has a raw material
					++numSourced;                        //increment this
			}
			if (list_440_460.size() > minDistanceSample) {      //only calculate with sufficient sample
				percentSourced_440_460 = (double) numSourced/ (double) list_440_460.size() * 100; //calculate percentage
			}
			numSourced = 0; //return this to 0 for next calculation
		}
		
		if (list_460_480.size() != 0){         //if there are artifacts on list
			
			for (Artifact tool : list_460_480) {    //go through list
				if (tool.getLithicRawMaterial() != null)  //if it has a raw material
					++numSourced;                        //increment this
			}
			if (list_460_480.size() > minDistanceSample) {      //only calculate with sufficient sample
				percentSourced_460_480 = (double) numSourced/ (double) list_460_480.size() * 100; //calculate percentage
			}
			numSourced = 0; //return this to 0 for next calculation
		}
		
		if (list_480_500.size() != 0){         //if there are artifacts on list
			
			for (Artifact tool : list_480_500) {    //go through list
				if (tool.getLithicRawMaterial() != null)  //if it has a raw material
					++numSourced;                        //increment this
			}
			if (list_480_500.size() > minDistanceSample) {      //only calculate with sufficient sample
				percentSourced_480_500 = (double) numSourced/ (double) list_480_500.size() * 100; //calculate percentage
			}
			numSourced = 0; //return this to 0 for next calculation
		}
		
		if (list_500_520.size() != 0){         //if there are artifacts on list
			
			for (Artifact tool : list_500_520) {    //go through list
				if (tool.getLithicRawMaterial() != null)  //if it has a raw material
					++numSourced;                        //increment this
			}
			if (list_500_520.size() > minDistanceSample) {      //only calculate with sufficient sample
				percentSourced_500_520 = (double) numSourced / (double) list_500_520.size() * 100; //calculate percentage
			}
			numSourced = 0; //return this to 0 for next calculation
		}
		
		if (list_520_540.size() != 0){         //if there are artifacts on list
			
			for (Artifact tool : list_520_540) {    //go through list
				if (tool.getLithicRawMaterial() != null)  //if it has a raw material
					++numSourced;                        //increment this
			}
			if (list_520_540.size() > minDistanceSample) {      //only calculate with sufficient sample
				percentSourced_520_540 = (double) numSourced/ (double) list_520_540.size() * 100; //calculate percentage
			}
			numSourced = 0; //return this to 0 for next calculation
		}
	
		if (list_540_560.size() != 0){         //if there are artifacts on list
			for (Artifact tool : list_540_560) {    //go through list
				if (tool.getLithicRawMaterial() != null)  //if it has a raw material
					++numSourced;                        //increment this
			}
			if (list_540_560.size() > minDistanceSample) {      //only calculate with sufficient sample
				percentSourced_540_560 = (double) numSourced/ (double) list_540_560.size() * 100; //calculate percentage
			}
			numSourced = 0; //return this to 0 for next calculation
		}
		
		if (list_560_580.size() != 0){         //if there are artifacts on list
			
			for (Artifact tool : list_560_580) {    //go through list
				if (tool.getLithicRawMaterial() != null)  //if it has a raw material
					++numSourced;                        //increment this
			}
			if (list_560_580.size() > minDistanceSample) {      //only calculate with sufficient sample
				percentSourced_560_580 = (double) numSourced/ (double) list_560_580.size() * 100; //calculate percentage
			}
			numSourced = 0; //return this to 0 for next calculation
		}
		
		if (list_580_600.size() != 0){         //if there are artifacts on list
			
			for (Artifact tool : list_580_600) {    //go through list
				if (tool.getLithicRawMaterial() != null)  //if it has a raw material
					++numSourced;                        //increment this
			}
			if (list_580_600.size() > minDistanceSample) {      //only calculate with sufficient sample
				percentSourced_580_600 = (double) numSourced/ (double) list_580_600.size() * 100; //calculate percentage
			}
			numSourced = 0; //return this to 0 for next calculation
		}
		
		if (list_600_620.size() != 0){         //if there are artifacts on list
			
			for (Artifact tool : list_600_620) {    //go through list
				if (tool.getLithicRawMaterial() != null)  //if it has a raw material
					++numSourced;                        //increment this
			}
			if (list_600_620.size() > minDistanceSample) {      //only calculate with sufficient sample
				percentSourced_600_620 = (double) numSourced / (double) list_600_620.size() * 100; //calculate percentage
			}
			
			numSourced = 0; //return this to 0 for next calculation
		}
		
		if (list_620_640.size() != 0){         //if there are artifacts on list
			
			for (Artifact tool : list_620_640) {    //go through list
				if (tool.getLithicRawMaterial() != null)  //if it has a raw material
					++numSourced;                        //increment this
			}
			if (list_620_640.size() > minDistanceSample) {      //only calculate with sufficient sample
				percentSourced_620_640 = (double) numSourced/ (double) list_620_640.size() * 100; //calculate percentage
			}
			numSourced = 0; //return this to 0 for next calculation
		}
	
		if (list_640_660.size() != 0){         //if there are artifacts on list
			
			for (Artifact tool : list_640_660) {    //go through list
				if (tool.getLithicRawMaterial() != null)  //if it has a raw material
					++numSourced;                        //increment this
			}
			if (list_640_660.size() > minDistanceSample) {      //only calculate with sufficient sample
				percentSourced_640_660 = (double) numSourced/ (double) list_640_660.size() * 100; //calculate percentage
			}
			numSourced = 0; //return this to 0 for next calculation
		}
		
		if (list_660_680.size() != 0){         //if there are artifacts on list
			
			for (Artifact tool : list_660_680) {    //go through list
				if (tool.getLithicRawMaterial() != null)  //if it has a raw material
					++numSourced;                        //increment this
			}
			
			if (list_660_680.size() > minDistanceSample) {      //only calculate with sufficient sample
					percentSourced_660_680 = (double) numSourced/ (double) list_660_680.size() * 100; //calculate percentage
			}
			numSourced = 0; //return this to 0 for next calculation
		}
		
		if (list_680_700.size() != 0){         //if there are artifacts on list
			
			for (Artifact tool : list_680_700) {    //go through list
				if (tool.getLithicRawMaterial() != null)  //if it has a raw material
					++numSourced;                        //increment this
			}
			
			if (list_680_700.size() > minDistanceSample) {      //only calculate with sufficient sample	
				percentSourced_680_700 = (double) numSourced/ (double) list_680_700.size() * 100; //calculate percentage
			}
			numSourced = 0; //return this to 0 for next calculation
		}
		
		if (list_700_720.size() != 0){         //if there are artifacts on list
			for (Artifact tool : list_700_720) {    //go through list
				if (tool.getLithicRawMaterial() != null)  //if it has a raw material
					++numSourced;                        //increment this
			}
			if (list_700_720.size() > minDistanceSample) {      //only calculate with sufficient sample
				percentSourced_700_720 = (double) numSourced/ (double) list_700_720.size() * 100; //calculate percentage
			}
			numSourced = 0; //return this to 0 for next calculation
		}
		
		
		if (list_720_740.size() != 0){         //if there are artifacts on list
			
			for (Artifact tool : list_720_740) {    //go through list
				if (tool.getLithicRawMaterial() != null)  //if it has a raw material
					++numSourced;                        //increment this
			}
			if (list_720_740.size() > minDistanceSample) {      //only calculate with sufficient sample
				percentSourced_720_740 = (double) numSourced/ (double) list_720_740.size() * 100; //calculate percentage
			}
			numSourced = 0; //return this to 0 for next calculation
		}
	
		if (list_740_760.size() != 0){         //if there are artifacts on list
			for (Artifact tool : list_740_760) {    //go through list
				if (tool.getLithicRawMaterial() != null)  //if it has a raw material
					++numSourced;                        //increment this
			}
			if (list_740_760.size() > minDistanceSample) {      //only calculate with sufficient sample
				percentSourced_740_760 = (double) numSourced/ (double) list_740_760.size() * 100; //calculate percentage
			}
			numSourced = 0; //return this to 0 for next calculation
		}
		
		if (list_760_780.size() != 0){         //if there are artifacts on list
			
			for (Artifact tool : list_760_780) {    //go through list
				if (tool.getLithicRawMaterial() != null)  //if it has a raw material
					++numSourced;                        //increment this
			}
			if (list_760_780.size() > minDistanceSample) {      //only calculate with sufficient sample
				percentSourced_760_780 = (double) numSourced/ (double) list_760_780.size() * 100; //calculate percentage
			}
			numSourced = 0; //return this to 0 for next calculation
		}
		
		if (list_780_800.size() != 0){         //if there are artifacts on list
			
			for (Artifact tool : list_780_800) {    //go through list
				if (tool.getLithicRawMaterial() != null)  //if it has a raw material
					++numSourced;                        //increment this
			}
			if (list_780_800.size() > minDistanceSample) {      //only calculate with sufficient sample
				percentSourced_780_800 = (double) numSourced/ (double) list_780_800.size() * 100; //calculate percentage
			}
			numSourced = 0; //return this to 0 for next calculation
		}
		
		if (list_800_820.size() != 0){         //if there are artifacts on list
			
			for (Artifact tool : list_800_820) {    //go through list
				if (tool.getLithicRawMaterial() != null)  //if it has a raw material
					++numSourced;                        //increment this
			}
			if (list_800_820.size() > minDistanceSample) {      //only calculate with sufficient sample
				percentSourced_800_820 = (double) numSourced / (double) list_800_820.size() * 100; //calculate percentage
			}
			
			numSourced = 0; //return this to 0 for next calculation
		}
		
		if (list_820_840.size() != 0){         //if there are artifacts on list
			
			for (Artifact tool : list_820_840) {    //go through list
				if (tool.getLithicRawMaterial() != null)  //if it has a raw material
					++numSourced;                        //increment this
			}
			if (list_820_840.size() > minDistanceSample) {      //only calculate with sufficient sample
				percentSourced_820_840 = (double) numSourced/ (double) list_820_840.size() * 100; //calculate percentage
			}
			numSourced = 0; //return this to 0 for next calculation
		}
	
		if (list_840_860.size() != 0){         //if there are artifacts on list
			
			for (Artifact tool : list_840_860) {    //go through list
				if (tool.getLithicRawMaterial() != null)  //if it has a raw material
					++numSourced;                        //increment this
			}
			if (list_840_860.size() > minDistanceSample) {      //only calculate with sufficient sample
				percentSourced_840_860 = (double) numSourced/ (double) list_840_860.size() * 100; //calculate percentage
			}
			numSourced = 0; //return this to 0 for next calculation
		}
		
		if (list_860_880.size() != 0){         //if there are artifacts on list
			
			for (Artifact tool : list_860_880) {    //go through list
				if (tool.getLithicRawMaterial() != null)  //if it has a raw material
					++numSourced;                        //increment this
			}
			
			if (list_860_880.size() > minDistanceSample) {      //only calculate with sufficient sample
				percentSourced_860_880 = (double) numSourced/ (double) list_860_880.size() * 100; //calculate percentage
			}
			numSourced = 0; //return this to 0 for next calculation
		}
		
		if (list_880_900.size() != 0){         //if there are artifacts on list
			
			for (Artifact tool : list_880_900) {    //go through list
				if (tool.getLithicRawMaterial() != null)  //if it has a raw material
					++numSourced;                        //increment this
			}
			
			if (list_880_900.size() > minDistanceSample) {      //only calculate with sufficient sample
				percentSourced_880_900 = (double) numSourced/ (double) list_880_900.size() * 100; //calculate percentage
			}
			numSourced = 0; //return this to 0 for next calculation
		}
		
		if (list_900_920.size() != 0){         //if there are artifacts on list
			
			for (Artifact tool : list_900_920) {    //go through list
				if (tool.getLithicRawMaterial() != null)  //if it has a raw material
					++numSourced;                        //increment this
			}
			if (list_900_920.size() > minDistanceSample) {      //only calculate with sufficient sample
				percentSourced_900_920 = (double) numSourced / (double) list_900_920.size() * 100; //calculate percentage
			}
			numSourced = 0; //return this to 0 for next calculation
		}
		
		if (list_920_940.size() != 0){         //if there are artifacts on list
			
			for (Artifact tool : list_920_940) {    //go through list
				if (tool.getLithicRawMaterial() != null)  //if it has a raw material
					++numSourced;                        //increment this
			}
			if (list_920_940.size() > minDistanceSample) {      //only calculate with sufficient sample
			percentSourced_920_940 = (double) numSourced/ (double) list_920_940.size() * 100; //calculate percentage
			}
			numSourced = 0; //return this to 0 for next calculation
		}
	
		if (list_940_960.size() != 0){         //if there are artifacts on list
			
			for (Artifact tool : list_940_960) {    //go through list
				if (tool.getLithicRawMaterial() != null)  //if it has a raw material
					++numSourced;                        //increment this
			}
			if (list_940_960.size() > minDistanceSample) {      //only calculate with sufficient sample
			percentSourced_940_960 = (double) numSourced/ (double) list_940_960.size() * 100; //calculate percentage
			}
			numSourced = 0; //return this to 0 for next calculation
		}
		
		if (list_960_980.size() != 0){         //if there are artifacts on list
			
			for (Artifact tool : list_960_980) {    //go through list
				if (tool.getLithicRawMaterial() != null)  //if it has a raw material
					++numSourced;                        //increment this
			}
			
			if (list_960_980.size() > minDistanceSample) {      //only calculate with sufficient sample
				percentSourced_960_980 = (double) numSourced/ (double) list_960_980.size() * 100; //calculate percentage
			}
			numSourced = 0; //return this to 0 for next calculation
		}
		
		if (list_980_1000.size() != 0){         //if there are artifacts on list
			
			for (Artifact tool : list_980_1000) {    //go through list
				if (tool.getLithicRawMaterial() != null)  //if it has a raw material
					++numSourced;                        //increment this
			}
			
			if (list_980_1000.size() > minDistanceSample) {      //only calculate with sufficient sample
				percentSourced_980_1000 = (double) numSourced/ (double) list_980_1000.size() * 100; //calculate percentage
			}
			numSourced = 0; //return this to 0 for next calculation
		}
	}
	
	//MODEL METHOD 18: Clear Distance Bin Lists
	public static void clearDistanceLists() {
		list_0_20.clear();
		list_20_40.clear();
		list_40_60.clear();
		list_60_80.clear();
		list_80_100.clear();
		list_100_120.clear();
		list_120_140.clear();
		list_140_160.clear();
		list_160_180.clear();
		list_180_200.clear();
		list_200_220.clear();
		list_220_240.clear();
		list_240_260.clear();
		list_260_280.clear();
		list_280_300.clear();
		list_300_320.clear();
		list_320_340.clear();
		list_340_360.clear();
		list_360_380.clear();
		list_380_400.clear();
		list_400_420.clear();
		list_420_440.clear();
		list_440_460.clear();
		list_460_480.clear();
		list_480_500.clear();
		list_500_520.clear();
		list_520_540.clear();
		list_540_560.clear();
		list_560_580.clear();
		list_580_600.clear();
		list_600_620.clear();
		list_620_640.clear();
		list_640_660.clear();
		list_660_680.clear();
		list_680_700.clear();
		list_700_720.clear();
		list_720_740.clear();
		list_740_760.clear();
		list_760_780.clear();
		list_780_800.clear();
		list_800_820.clear();
		list_820_840.clear();
		list_840_860.clear();
		list_860_880.clear();
		list_880_900.clear();
		list_900_920.clear();
		list_920_940.clear();
		list_940_960.clear();
		list_960_980.clear();
		list_980_1000.clear();
	}
	
	//MODEL METHOD 19: Null Discarded Artifacts
		public void nullDiscardedArtifacts() {
			for (Artifact artifactToNull : discardList) {
				artifactToNull = null;
			}
		}
	
	//MODEL METHOD 20: End Run	
	public void endRun() {
		
		clearDistanceLists();                  //call this again to try to fix "carryover" problem

		Style_Net_01Builder.nullContext();            //ask the builder to null stuff

		System.gc(); // garbage collector
		RunEnvironment.getInstance().endRun(); // end the run
	}

	// SETTERS AND GETTERS
	public static int getTimePeriod() {
		return timePeriod;
	}
	
	public static int getCurrentTick() {
		return currentTick; 
	}
	
	public static int getSizeX() {
		return sizeX;
	}

	public void setSizeX(int szX) {
		sizeX = szX;
	}

	public static int getSizeY() {
		return sizeY;
	}

	public void setSizeY(int szY) {
		sizeY = szY;
	}

	public static int getNumPersonsPerAggSite() {
		return numPersonsPerAggSite;
	}

	public void setNumPersonsPerAggSite(int nppas) {
		numPersonsPerAggSite = nppas;
	}
	
	public static int getNumAggSites() { return numAggSites; }
	
	public static int getNumLithicSources() {return numLithicSources; }

	public static int getSeason() {return season;}
	
	public static int getSeasonTick() {return seasonTick;}

	public static int getToolInventorySize() {return toolInventorySize;}

	public static int getToolUseLife() {return toolUseLife;}

	public static int getToolUsesPerStep() {return toolUsesPerStep;}
	
	public static int getProductionFactor() {return productionFactor;}

	public static boolean getReplacement() {return replacement;}
	
	public static AggSite getAggSiteFromList(int i) {
		AggSite getAgg = aggSiteList.get(i);
		return getAgg;
	}

	public static LithicSource getLithicSourceFromList(int i) {
		LithicSource getLithicSource = lithicSourceList.get(i);
		return getLithicSource;
	}
	
	public static Person getPersonFromList(int i) {
		Person getPerson = personList.get(i);
		return getPerson;
	}

	public static Group getGroupFromList(int i) {
		Group getGroup = groupList.get(i);
		return getGroup;
	}

	public static double getPInterAggMovement() {
		return pInterAggMovement;
	}

	public static int getMaxGroupSize() {
		return maxGroupSize;
	}
	
	public static double getMaxRangeKm() { return maxRangeKm; }
	
	public static void setMaxRangeKm (double mrkm) { 
		maxRangeKm = mrkm; 
	}

	public static void incrementNumInterAggMoves() {
		++numInterAggMoves;
	}

	public static void incrementNumInterGroupMoves() {
		++numInterGroupMoves;
	}
	
	public static void recordArtifact(Artifact removeTool) {
		discardList.add (removeTool);
	}
		
	public static int getPersonalMobilityRadius() {
		return personalMobilityRadius; 
	}
}
